'''


Background subtraction

Pixel by pixel subtraction of background noise from non-IR sources (Pcal beam, green laser, ect)

'''

import rawpy
import imageio
import numpy as np
from PIL import Image
import glob
import os
import csv

def backgroundSubtraction():

	directory = 'ETMx//Unlocked//'
	saturated_value = 2**14 - 1
	num_channels = 3


	#camera calibration doe at ISO 200, linear scaling factors for different ISOs
	#ie 1 for ISO 200, 4 for ISO 800
	iso_factors = np.array(
		[100/200, 100/200, 100/200, 100/200, 100/200, 
		100/200, 100/200, 100/200, 100/200, 100/200, 
		100/200, 100/200, 100/200, 100/200, 100/200, 
		100/200, 100/200, 100/200, 100/200])

	#in seconds
	#enter the values that your pictures are in
	exposure_times = np.array([1/25, 1/30, 1/40, 1/60, 1/125, 1/250, 1/500, 1/1000, 1/2000, 1/3200, 
	1/5000, 1/6400, 1/8000, 1/15, 1/5, 1/2, 1, 1/10, 2/5])


	#rgb
	dark_offset = []

	#transmitivity of the lens
	lens_transmitivity = 1

	#names of folder paths to analyze
	folders = [

	]

	#keeps track of where to add the next image in the 2d array of allImages
	counter = 0 

	#stores where all the images are
	allImages = []

	#gets all the images organized in the folders and adds them to allImages
	#NOTE: will have to change the directory back the location of measureEnergy.py
	for folder in folders:
		os.chdir(directory+folder)
		allImages.append([])
		for image in glob.glob('*.NEF'):
			allImages[counter].append(image)
			print(image)
		os.chdir('..')
		os.chdir('..')
		os.chdir('..')
		counter = counter + 1

	
		

